
QGIS Application - Bug report #18698

qgsgml.cpp and gdal 2.4.4 incompatibility? (DEBUG build)

2018-04-10 05:13 PM - vince -

Status: Closed

Priority: Normal

Assignee:

Category: Build/Install

Affected QGIS version:3.1(master) Regression?: No

Operating System: OS X Easy fix?: Yes

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 26586

Description

When I try to compile QGIS master (commit c625f95) with the new version of gdal, I get this compilation error:

src/core/qgsgml.cpp:883:29: error: no matching function for call to 'OGR_G_WkbSize'

        const int wkbSize = OGR_G_WkbSize( hGeom.get() );

                            ^~~~~~~~~~~~~

/opt/local/include/ogr_api.h:118:16: note: candidate function not viable: cannot convert argument of incomplete type

'std::__1::unique_ptr<void, gdal::OGRGeometryDeleter>::pointer' (aka 'void *') to 'OGRGeometryH' (aka 'OGRGeometryHS *') for

1st argument

int    CPL_DLL OGR_G_WkbSize( OGRGeometryH hGeom );

               ^

src/core/qgsgml.cpp:885:9: error: no matching function for call to 'OGR_G_ExportToIsoWkb'

        OGR_G_ExportToIsoWkb( hGeom.get(), wkbNDR, pabyBuffer );

        ^~~~~~~~~~~~~~~~~~~~

/opt/local/include/ogr_api.h:117:16: note: candidate function not viable: cannot convert argument of incomplete type

'std::__1::unique_ptr<void, gdal::OGRGeometryDeleter>::pointer' (aka 'void *') to 'OGRGeometryH' (aka 'OGRGeometryHS *') for

1st argument

OGRErr CPL_DLL OGR_G_ExportToIsoWkb( OGRGeometryH, OGRwkbByteOrder, unsigned char*);

This seems to be caused by the upgrade from gdal 2.4.3 to gdal 2.4.4.

Related issues:

Duplicates QGIS Application - Bug report # 18696: libdxfrw doesn’t honor the ... Closed 2018-04-10

History

#1 - 2018-04-10 05:57 PM - vince -

- Subject changed from qgsgml.cpp and gdal 2.4.4 incompatibility?  to qgsgml.cpp and gdal 2.4.4 incompatibility? (DEBUG build)

#2 - 2018-04-10 06:00 PM - vince -

This is a DEBUG build, and it fails because of that line in ogr_api.h

#ifdef DEBUG

typedef struct OGRGeometryHS *OGRGeometryH;

#else

/** Opaque type for a geometyr */

typedef void *OGRGeometryH;

#endif
#3 - 2018-04-11 11:47 PM - Jürgen Fischer

- Resolution set to fixed/implemented

- Status changed from Open to Closed

Fixed in commit:222e45b838ebf8a2df43c6ef888047182fba5cb2

#4 - 2018-04-11 11:48 PM - Jürgen Fischer

- Duplicates Bug report #18696: libdxfrw doesn’t honor the "DEBUG" flag added
